VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CListView"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
' File Name: modListViewEnh.mod
' Last Revision: Wednesday, October 13, 1999
'
' Assumes: None
'
' Number of Functions: 24
'
' Includes: EnhListView_ResizeColumns(m_lsv As ListView, Optional bolShowErrors As Boolean) As Boolean
' Type: Public Function
' Description: Resizes all Columns in a ListView to fit the text in the rows
'
' Includes: EnhListView_SortColumns(m_lsv As ListView, usdColIndex, Optional bolShowErrors As Boolean) As Boolean
' Type: Public Function
' Description: Use on ColumnClick to sort by that Column
' Toggles between Ascending and Descending Sorts
'
' Includes: EnhListView_ResizeColumnCaptions(m_lsv As ListView, Optional bolShowErrors As Boolean) As Boolean
' Type: Public Function
' Description: Resizes all Columns in a ListView to the Text in the Column Caption
'
' Includes: EnhListView_ResizeColumnHeaders(m_lsv As ListView, Optional bolShowErrors As Boolean) As Boolean
' Type: Public Function
' Description: Resizes the ColumnHeaders in a ListView to the Width
' of the ListView
'
' Includes: EnhListView_Add_FullRowSelect( m_lsv As ListView, Optional bolShowErrors As Boolean) As Boolean
' Type: Public Function
' Description: Enables Full Row Select in a ListView
'
' Includes: EnhListView_Rem_FullRowSelect( m_lsv As ListView, Optional bolShowErrors As Boolean) As Boolean
' Type: Public Function
' Description: Disables Full Row Select in a ListView
'
' Includes: EnhListView_Add_GridLines( m_lsv As ListView, Optional bolShowErrors As Boolean) As Boolean
' Type: Public Function
' Description: Enables GridLines in a ListView
'
' Includes: EnhListView_Rem_GridLines( m_lsv As ListView, Optional bolShowErrors As Boolean) As Boolean
' Type: Public Function
' Description: Disables GridLines in a ListView
'
' Includes: EnhListView_Add_CheckBoxes( m_lsv As ListView, Optional bolShowErrors As Boolean) As Boolean
' Type: Public Function
' Description: Enables CheckBoxes in a ListView
'
' Includes: EnhListView_Rem_CheckBoxes( m_lsv As ListView, Optional bolShowErrors As Boolean) As Boolean
' Type: Public Function
' Description: Disables CheckBoxes in a ListView
'
' Includes: EnhListView_Add_AllowRepositioning( m_lsv As ListView, Optional bolShowErrors As Boolean) As Boolean
' Type: Public Function
' Description: Enables Repositioning of ColumnHeaders in a ListView
'
' Includes: EnhListView_Rem_AllowRepositioning( m_lsv As ListView, Optional bolShowErrors As Boolean) As Boolean
' Type: Public Function
' Description: Disables Repositioning of ColumnHeaders in a ListView
'
' Includes: EnhListView_Add_TrackSelected( m_lsv As ListView, Optional bolShowErrors As Boolean) As Boolean
' Type: Public Function
' Description: Enables TrackSelected in a ListView
'
' Includes: EnhListView_Rem_TrackSelected( m_lsv As ListView, Optional bolShowErrors As Boolean) As Boolean
' Type: Public Function
' Description: Disables TrackSelected in a ListView
'
' Includes: EnhListView_Add_OneClickActivate( m_lsv As ListView, Optional bolShowErrors As Boolean) As Boolean
' Type: Public Function
' Description: Enables One Click Activate in a ListView
'
' Includes: EnhListView_Rem_OneClickActivate( m_lsv As ListView, Optional bolShowErrors As Boolean) As Boolean
' Type: Public Function
' Description: Disables One Click Activate in a ListView
'
' Includes: EnhListView_Add_TwoClickActivate( m_lsv As ListView, Optional bolShowErrors As Boolean) As Boolean
' Type: Public Function
' Description: Enables Two Click Activate in a ListView
'
' Includes: EnhListView_Rem_TwoClickActivate( m_lsv As ListView, Optional bolShowErrors As Boolean) As Boolean
' Type: Public Function
' Description: Enables Full Row Select in a ListView
'
' Includes: EnhListView_Add_SubitemImages( m_lsv As ListView, Optional bolShowErrors As Boolean) As Boolean
' Type: Public Function
' Description: Enables SubItem Images in a ListView
'
' Includes: EnhListView_Rem_SubitemImages( m_lsv As ListView, Optional bolShowErrors As Boolean) As Boolean
' Type: Public Function
' Description: Disables SubItem Images in a ListView
'
' Includes: EnhLitView_CheckAllItems( m_lsv As ListView, Optional bolShowErrors As Boolean) As Boolean
' Type: Public Function
' Description: Checks all Items in the ListView
'
' Includes: EnhLitView_UnCheckAllItems( m_lsv As ListView, Optional bolShowErrors As Boolean) As Boolean
' Type: Public Function
' Description: Unchecks all items in a ListView
'
' Includes: EnhListView_InvertAllChecks( m_lsv As ListView, Optional bolShowErrors As Boolean) As Boolean
' Type: Public Function
' Description: Inverts all checked items in a ListView
'
' Includes: EnhListView_Toggle_FlatColumnHeaders( frmFormName As Form, m_lsv As ListView, Optional bolShowErrors As Boolean) As Boolean
' Type: Public Function
' Description: Toggles FlatColumnHeaders in a ListView
'
' Variable Name: LengthPerCharacter
' Type: Long
' Description: Used to set the length in twips per character for column spacing
' Defaults to 80 if not specified
'
' Disclaimer:
' Code provided by John Allan Lee 'as is', without warranties as to
' performance, fitness, merchantability, and any other warranty
' (whether expressed or implied).
' This source code is copyrighted by John Allan Lee who has exclusive
' rights to distribute it.
'
' Freeware:
' Code is freely redistributable for personal use in source code form,
' or for personal or business use in a non-source code binary executable.
' All other redistributions are prohibited without express written consent
' from John Allan Lee.
 
Dim m_lsv As ListView
Dim m_HeaderFont_Bold As Boolean
Dim m_HeaderFont_Italic As Boolean
Dim m_HeaderFont_Underline As Boolean
Dim m_HeaderFont_StrikeOut As Boolean
Dim m_GridLines As Boolean
Dim m_FullRowSelect As Boolean
Dim m_LengthPerCharacter As Long

' needed for Enhancements
Private Const LVIS_STATEIMAGEMASK As Long = &HF000
Private Type LVITEM
    mask As Long
    iItem As Long
    iSubItem As Long
    state As Long
    stateMask As Long
    pszText As String
    cchTextMax As Long
    iImage As Long
    lParam As Long
    iIndent As Long
End Type
Const SWP_DRAWFRAME = &H20
Const SWP_NOMOVE = &H2
Const SWP_NOSIZE = &H1
Const SWP_NOZORDER = &H4
Private Const LVS_EX_FULLROWSELECT = &H20
Private Const LVS_EX_GRIDLINES = &H1
Private Const LVS_EX_CHECKBOXES As Long = &H4
Private Const LVS_EX_HEADERDRAGDROP = &H10
Private Const LVS_EX_TRACKSELECT = &H8
Private Const LVS_EX_ONECLICKACTIVATE = &H40
Private Const LVS_EX_TWOCLICKACTIVATE = &H80
Private Const LVS_EX_SUBITEMIMAGES = &H2
Private Const LVM_FIRST = &H1000
Private Const LVM_SETEXTENDEDLISTVIEWSTYLE = LVM_FIRST + 54
Private Const LVM_GETEXTENDEDLISTVIEWSTYLE = LVM_FIRST + 55
Private Const LVM_GETHEADER = (LVM_FIRST + 31)
Private Const LVIF_STATE = &H8
Private Const LVM_SETITEMSTATE = (LVM_FIRST + 43)
Private Const LVM_GETITEMSTATE As Long = (LVM_FIRST + 44)
Private Const HDS_BUTTONS = &H2
Private Const GWL_STYLE = (-16)
Private Const SWP_FLAGS = SWP_NOZORDER Or SWP_NOSIZE Or SWP_NOMOVE Or SWP_DRAWFRAME
' Aggiunte per l'header font
Private Const LVIF_INDENT As Long = &H10
Private Const LVIF_TEXT As Long = &H1
Private Const LVIF_PARAM = &H4
Private Const LVIF_STATE = &H8
Private Const LVIF_IMAGE = &H2

Private Type LOGFONT
    lfHeight As Long
    lfWidth As Long
    lfEscapement As Long
    lfOrientation As Long
    lfWeight As Long
    lfItalic As Byte
    lfUnderline As Byte
    lfStrikeOut As Byte
    lfCharSet As Byte
    lfOutPrecision As Byte
    lfClipPrecision As Byte
    lfQuality As Byte
    lfPitchAndFamily As Byte
    lfFaceName(LF_FACESIZE - 1) As Byte
End Type
Declare Function CreateFontIndirect Lib "gdi32" Alias "CreateFontIndirectA" (lpLogFont As LOGFONT) As Long
Declare Function GetObject Lib "gdi32" Alias "GetObjectA" (ByVal hObject As Long, ByVal nCount As Long, lpObject As Any) As Long
Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
' Fine aggiunte per l'header font


Public Declare Function SendMessageAny _
    Lib "user32" _
    Alias "SendMessageA" _
    (ByVal hwnd As Long, _
    ByVal Msg As Long, _
    ByVal wParam As Long, _
    lParam As Any) _
    As Long
Private Declare Function SendMessageLong Lib _
    "user32" Alias _
    "SendMessageA" _
    (ByVal hwnd As Long, _
    ByVal Msg As Long, _
    ByVal wParam As Long, _
    ByVal lParam As Long) _
    As Long
Private Declare Function GetWindowLong _
    Lib "user32" _
    Alias "GetWindowLongA" _
    (ByVal hwnd As Long, _
    ByVal nIndex As Long) _
    As Long
Private Declare Function SetWindowLong _
    Lib "user32" _
    Alias "SetWindowLongA" _
    (ByVal hwnd As Long, _
    ByVal nIndex As Long, _
    ByVal dwNewLong As Long) _
    As Long
Private Declare Function SetWindowPos _
    Lib "user32" _
    (ByVal hwnd As Long, _
    ByVal hWndInsertAfter As Long, _
    ByVal x As Long, _
    ByVal Y As Long, _
    ByVal cx As Long, _
    ByVal cy As Long, _
    ByVal wFlags As Long) _
    As Long

'=======================================================================
'=======================================================================
' Description: Resizes all Columns in a ListView to fit the text in
' the rows
'=======================================================================
Public Function EnhListView_ResizeColumns( _
        Optional bolShowErrors As Boolean) _
        As Boolean
    
    '_______________________________________________________________________
    ' initiate error handler
    On Error GoTo err_EnhListView_ResizeColumns
    
    '_______________________________________________________________________
    ' set function return to true
    EnhListView_ResizeColumns = True
    
    '_______________________________________________________________________
    ' if the user has not set LengthPerCharacter use 80
    If LengthPerCharacter = 0 Then LengthPerCharacter = "80"
    
    '_______________________________________________________________________
    ' if there are columns to go through...
    If m_lsv.ListItems.Count > 0 Then
        ' setup variables
        Dim lngIndexCounter As Long
        Dim lngColumnCounter As Long
        ' move through each column
        For lngColumnCounter = 1 To m_lsv.ColumnHeaders.Count
            ' move though each entry
            For lngIndexCounter = 1 To m_lsv.ListItems.Count
                ' if it is not the first column
                If lngColumnCounter > 1 Then
                    ' size the column 85 twips per letter
                    If Len(m_lsv.ListItems.Item(lngIndexCounter).SubItems(lngColumnCounter - 1)) * LengthPerCharacter > _
                        m_lsv.ColumnHeaders.Item(lngColumnCounter).Width Then
                    m_lsv.ColumnHeaders.Item(lngColumnCounter).Width = _
                        Len(m_lsv.ListItems.Item(lngIndexCounter).SubItems(lngColumnCounter - 1)) * LengthPerCharacter
                End If
                ' if it is the first column
            Else
                ' size the column 85 twips per letter
                If Len(m_lsv.ListItems.Item(lngIndexCounter).Text) * LengthPerCharacter > _
                    m_lsv.ColumnHeaders.Item(lngColumnCounter).Width Then
                m_lsv.ColumnHeaders.Item(lngColumnCounter).Width = _
                    Len(m_lsv.ListItems.Item(lngIndexCounter).Text) * LengthPerCharacter
            End If
        End If
    Next lngIndexCounter
Next lngColumnCounter
End If
'_______________________________________________________________________
' exit before error handler
Exit Function
'_______________________________________________________________________
' deal with errors
err_EnhListView_ResizeColumns:
'_______________________________________________________________________
' set function return to false
EnhListView_ResizeColumns = False
'_______________________________________________________________________
' if you want notification on an error
If bolShowErrors = True Then
MsgBox "Error" & Err.Number & vbTab & Err.Description, _
    vbOKOnly + vbInformation, _
    "Error in Function : EnhListView_ResizeColumns"
End If
'_______________________________________________________________________
' initiate debug
Debug.Print Now & vbTab & "Error in function: EnhListView_ResizeColumns" _
    & vbCrLf & _
    Err.Number & vbTab & Err.Description
Debug.Assert False
'_______________________________________________________________________
' exit
Exit Function
End Function

'=======================================================================
'=======================================================================
' Description: Use on ColumnClick to sort by that Column
' Toggles between Ascending and Descending Sorts
'=======================================================================
Public Sub EnhListView_SortColumns(usdColIndex, Optional bolShowErrors As Boolean)
On Error GoTo err_EnhListView_SortColumns
    ' if there are columns to go through...
    If m_lsv.ListItems.Count > 0 Then
        ' if the sort property is turned off turn it on
        If m_lsv.Sorted = False Then m_lsv.Sorted = True
        ' set the sortby column
        m_lsv.SortKey = _
            m_lsv.ColumnHeaders.Item(usdColIndex).Index - 1
        ' if it's sorted ascending
        If m_lsv.SortOrder = lvwAscending Then
            ' sort it descending
            m_lsv.SortOrder = lvwDescending
            ' if it's sorted descending
        Else
            ' sort it ascending
            m_lsv.SortOrder = lvwAscending
        End If
    End If
    ' exit before error handler
    Exit Sub

' deal with errors
err_EnhListView_SortColumns:
    ' if you want notification on an error
    If bolShowErrors = True Then
    MsgBox "Error" & Err.Number & vbTab & Err.Description, _
        vbOKOnly + vbInformation, _
        "Error in Function : EnhListView_SortColumns"
    End If
    ' initiate debug
    Debug.Print Now & vbTab & "Error in function: EnhListView_SortColumns" _
        & vbCrLf & _
        Err.Number & vbTab & Err.Description
    Debug.Assert False
    ' exit
    Exit Sub

End Sub

'=======================================================================
'=======================================================================
' Description: Resizes all Columns in a ListView to the Text in the
' Column Caption
'=======================================================================
Property Get LenPerCharacter() As Long
    LenPerCharacter = m_LengthPerCharacter
End Property
Property Let LenPerCharacter(lValue As Long)
    m_LengthPerCharacter = lValue
End Property
Public Sub EnhListView_ResizeColumnCaptions(Optional bolShowErrors As Boolean)
On Error GoTo err_EnhListView_ResizeColumnCaptions
    ' if the user has not set LengthPerCharacter use 80
    If m_LengthPerCharacter = 0 Then m_LengthPerCharacter = 80
    ' if there are columns to go through...
    If m_lsv.ListItems.Count > 0 Then

        ' setup variables
        Dim lngColumnCounter As Long
        ' move through each column
        For lngColumnCounter = 1 To m_lsv.ColumnHeaders.Count
            ' make the size of the column equal to 85 twips per character
            m_lsv.ColumnHeaders.Item(lngColumnCounter).Width = _
                Len(m_lsv.ColumnHeaders.Item(lngColumnCounter).Text) * LengthPerCharacter
        Next lngColumnCounter

    End If
    ' exit before error handler
    Exit Sub

' deal with errors
err_EnhListView_ResizeColumnCaptions:

    ' if you want notification on an error
    If bolShowErrors = True Then
        MsgBox "Error" & Err.Number & vbTab & Err.Description, _
            vbOKOnly + vbInformation, _
            "Error in Function : EnhListView_ResizeColumnCaptions"
    End If
    ' initiate debug
    Debug.Print Now & vbTab & "Error in function: EnhListView_ResizeColumnCaptions" _
        & vbCrLf & _
        Err.Number & vbTab & Err.Description
    Debug.Assert False
    ' exit
    Exit Sub

End Sub

'=======================================================================
'=======================================================================
' Description: Resizes the ColumnHeaders in a ListView to the Width
' of the ListView
'=======================================================================
Public Sub ResizeColumnHeaders(Optional bolShowErrors As Boolean)
' initiate error handler
On Error GoTo err_EnhListView_ResizeColumnHeaders
' setup variables
Dim lngColCounter As Long
Dim lngListViewDiv As Long
    
    ' fill variables
    lngListViewDiv = m_lsv.Width / m_lsv.ColumnHeaders.Count - 300
    For lngColCounter = 1 To m_lsv.ColumnHeaders.Count
        m_lsv.ColumnHeaders(lngColCounter).Width = lngListViewDiv
    Next lngColCounter
    ' exit before error handler
    Exit Sub

' deal with errors
err_EnhListView_ResizeColumnHeaders:
    ' if you want notification on an error
    If bolShowErrors = True Then
        MsgBox "Error" & Err.Number & vbTab & Err.Description, _
            vbOKOnly + vbInformation, _
            "Error in Function : EnhListView_ResizeColumnHeaders"
    End If
    ' initiate debug
    Debug.Print Now & vbTab & "Error in function: EnhListView_ResizeColumnHeaders" _
        & vbCrLf & _
        Err.Number & vbTab & Err.Description
    Debug.Assert False
    ' exit
    Exit Sub

End Sub

'=======================================================================
'=======================================================================
' Description: Enables/Disables Full Row Select in a ListView
'=======================================================================
Property Get FullRowSelect() As Boolean
    FullRowSelect = m_FullRowSelect
End Property
Property Let FullRowSelect(bState As Boolean)
    m_FullRowSelect = bState
    EnhListView_Add_FullRowSelect
End Property
Private Sub EnhListView_Add_FullRowSelect(Optional bolShowErrors As Boolean)
On Error GoTo err_EnhListView_Add_FullRowSelect
' setup variables
Dim rStyle As Long
Dim r As Long
    ' get the current styles
    rStyle = SendMessageLong(m_lsv.hwnd, LVM_GETEXTENDEDLISTVIEWSTYLE, 0&, 0&)
    ' add the selected style to the current styles
    If m_FullRowSelect Then
        rStyle = rStyle Or LVS_EX_FULLROWSELECT
    Else
        rStyle = 0&
    End If
    ' update the listview styles
    SendMessageLong m_lsv.hwnd, LVM_SETEXTENDEDLISTVIEWSTYLE, 0&, rStyle
    ' exit before error handler
    Exit Sub

err_EnhListView_Add_FullRowSelect:
    ' if you want notification on an error
    If bolShowErrors = True Then
        MsgBox "Error" & Err.Number & vbTab & Err.Description, _
            vbOKOnly + vbInformation, _
            "Error in Function : EnhListView_Add_FullRowSelect"
    End If
    ' initiate debug
    Debug.Print Now & vbTab & "Error in function: EnhListView_Add_FullRowSelect" _
        & vbCrLf & _
        Err.Number & vbTab & Err.Description
    Debug.Assert False
    ' exit
    Exit Sub

End Sub


'=======================================================================
'=======================================================================
' Description: Enables/Disables GridLines in a ListView
'=======================================================================
Property Get GridLines() As Boolean
    GridLines = m_GridLines
End Property
Property Let GridLines(bState As Boolean)
    m_GridLines = bState
    EnhListView_Add_GridLines
End Property
Private Sub EnhListView_Add_GridLines()
On Error GoTo err_EnhListView_Add_GridLines
Dim rStyle As Long
Dim r As Long
' set function return to true
EnhListView_Add_GridLines = True
    ' get the current styles
    rStyle = SendMessageLong(m_lsv.hwnd, LVM_GETEXTENDEDLISTVIEWSTYLE, 0&, 0&)
    ' add the selected style to the current styles
    If m_GridLines Xor CBool(rStyle And LVS_EX_GRIDLINES) Then
        rStyle = rStyle Or LVS_EX_GRIDLINES
    Else
        rStyle = 0&
    End If
    ' update the listview styles
    SendMessageLong m_lsv.hwnd, LVM_SETEXTENDEDLISTVIEWSTYLE, 0&, rStyle
    ' exit before error handler
    Exit Sub

' deal with errors
err_EnhListView_Add_GridLines:
    ' set function return to false
    EnhListView_Add_GridLines = False
    ' if you want notification on an error
    If bolShowErrors = True Then
        MsgBox "Error" & Err.Number & vbTab & Err.Description, _
            vbOKOnly + vbInformation, _
            "Error in Function : EnhListView_Add_GridLines"
    End If
    ' initiate debug
    Debug.Print Now & vbTab & "Error in function: EnhListView_Add_GridLines" _
        & vbCrLf & _
        Err.Number & vbTab & Err.Description
    Debug.Assert False

End Sub

'
'
'
'
Property Get HeaderFont_Bold() As Boolean
    m_HeaderFont_Bold = HeaderFont_Bold
End Property
Property Let HeaderFont_Bold(bState As Boolean)
    m_HeaderFont_Bold = bState
End Property
Property Get HeaderFont_Italic() As Boolean
    m_HeaderFont_Italic = HeaderFont_Italic
End Property
Property Let HeaderFont_Italic(bState As Boolean)
    m_HeaderFont_Italic = bState
End Property
Property Get HeaderFont_Underline() As Boolean
    m_HeaderFont_Underline = HeaderFont_Underline
End Property
Property Let HeaderFont_Underline(bState As Boolean)
    m_HeaderFont_Underline = bState
End Property
Property Get HeaderFont_StrikeOut() As Boolean
    m_HeaderFont_StrikeOut = HeaderFont_StrikeOut
End Property
Property Let HeaderFont_StrikeOut(bState As Boolean)
    m_HeaderFont_StrikeOut = bState
End Property
Sub SetHeaderFontStyle()
Dim LF As LOGFONT
Dim r As Long
Dim hCurrFont As Long
Dim hOldFont As Long
Dim hHeader As Long
Dim hHeaderFont As Long

    'Ottiene l'handle dell'intestazione
    hHeader = SendMessageLong(m_lsv.hwnd, LVM_GETHEADER, 0, 0)
    
    'Ottiene l'handle del font utilizzato nell'intestazione
    hCurrFont = SendMessageLong(hHeader, WM_GETFONT, 0, 0)
   
    'Ottiene i dettagli LOGFONT del font utilizzato
    r = GetObject(hCurrFont, Len(LF), LF)
    If r > 0 Then
        'Imposta gli attributi del font in base alle checkboxes relative
        'sulla maschera

        LF.lfWeight = IIf(m_HeaderFont_Bold, FW_BOLD, FW_NORMAL)
        LF.lfItalic = -m_HeaderFont_Italic
        LF.lfUnderline = -m_HeaderFont_Underline
        LF.lfStrikeOut = -m_HeaderFont_StrikeOut

        'Elimina il font precedente
        r = DeleteObject(hHeaderFont)
        
        'Crea il nuovo font
        hHeaderFont = CreateFontIndirect(LF)
        
        'Seleziona il nuovo font
        hOldFont = SelectObject(hHeader, hHeaderFont)
        
        'Informa la ListView che il font  cambiato
        r = SendMessageLong(hHeader, WM_SETFONT, hHeaderFont, True)
    End If

End Sub


'
'
'
'

Property Set lsvPointer(lsv As ListView)
    Set m_lsv = lsv
End Property
Private Sub Class_Terminate()
    Set m_lsv = Nothing
End Sub
